
#ifndef ENCODERS_H
#define ENCODERS_H

#include <Arduino.h> //needed for Serial.println


typedef struct {
    int pinA = 0; // Our first hardware interrupt pin
    int pinB = 0; // Our second hardware interrupt pin
    volatile byte aFlag = 0; // let's us know when we're expecting a rising edge on pinA to signal that the encoder has arrived at a detent
    volatile byte bFlag = 0; // let's us know when we're expecting a rising edge on pinB to signal that the encoder has arrived at a detent (opposite direction to when aFlag is set)
    volatile byte encoderPos = 0; //this variable stores our current value of encoder position. Change to int or uin16_t instead of byte if you want to record a larger range than 0-255
    volatile byte oldEncPos = 0; //stores the last encoder position value so we can compare to the current reading and see if it has changed
    volatile byte reading = 0; //somewhere to store the direct values we read from our interrupt pins before checking to see if we have moved a whole detent
    int change = 0; // difference between old and current value, ie +1 or -1 in general since it is reset everytime we send a message to FG.
} Encoder;
#define ENCODERMAXVALUE 255



extern int sendmsg;
#if NENCODERS > 0
extern Encoder encoder[NENCODERS];
#endif
void Enc0A();
void Enc0B();


void setupEncoders();
void calculateEncoders();
void printEncoders(const char *separator);
void clearEncoders();
void readEncoderPinA(Encoder *enc);
void readEncoderPinB(Encoder *enc);


#endif
