
#ifndef PUSHBUTTONS_H
#define PUSHBUTTONS_H

#include <Arduino.h> //needed for Serial.println


typedef struct  {
  int pin = 0;        // pin to read values from
  int state = 0;      // HIGH | LOW, ie pressed or not
  unsigned long timer = 0;     // time in ms when it was pressed (for debouncing)
} PushButton;

// Prevent bouncing:
// Every time a button is pressed the time will be stored.
// The state will not be read again until this amount of time
// has passed, to prevent bouncing of signal value.
const int button_debounce_delay = 50; // unit: ms


extern int sendmsg;
extern PushButton pushbuttons[NPUSHBUTTONS];


void setupPushButtons();
void readPushButtons();
void readPushButton(PushButton *btn);
void printPushButtons();

#endif
